/*
 * This file is part of tela the Tensor Language.
 * Copyright (c) 1994-1995 Pekka Janhunen
 */

/*
 * tunop1.C - 'template' for a kind-preserving unary operator that is applied to one object.
 * Included separately for Inc,Dec.
 */

void OPFNAME(Tobject& a) {
	int i;
	switch (a.kind()) {
	case Kint:
		OP(a.IntRef());
		global::nops++;
		break;
	case Kreal:
		OP(a.RealRef());
		global::nops++;
		break;
	case Kcomplex:
		OP(a.ComplexRef());
		global::nops++;
		break;
	case KIntArray:
		for (i=0; i<a.length(); i++) OP(a.IntPtr()[i]);
		global::nops+= a.length();
		break;
	case KRealArray:
		for (i=0; i<a.length(); i++) OP(a.RealPtr()[i]);
		global::nops+= a.length();
		break;
	case KComplexArray:
		for (i=0; i<a.length(); i++) OP(a.ComplexPtr()[i]);
		global::nops+= a.length();
		break;
	case KObjectArray:
	case Kfunction:
	case KCfunction:
	case KIntrinsicFunction:
	case Kvoid:
	case Kundef:
		UnaryError(OPCHAR,a);
		break;
	}
}
